// 
// Section: CSE 154
// Sample Dictionary code (used in 18sp midterm)
//
/* global Dexie */
(function() {
  
   let db = new Dexie("definitions");
   
  /**
   * Connect the add-entry button with the event handler
   */
  window.onload = function() {
    $("add-entry").onclick = addEntry;
    
    db.version(1).stores({
      terms: 'term,definition'
    });

  };

  /**
   * Function to handle adding an entry to the database. 
   */
  function addEntry() {
    let term = $("term").value;
    let definition = $("definition").value;
    if (term && definition) {

      let li = document.createElement("li");
      li.innerText = term + ": " + definition;
      $("entries").appendChild(li);
      $("current-entries").classList.remove("hidden");

      li.ondblclick = function() {
        // delete the term, which is before the : in the innerText of the li
        let term = this.innerText.split(":")[0]
        db.terms.delete(term);

        $("entries").removeChild(this);
        hideEntries();
      }
      $("term").value = "";
      $("definition").value = "";
      
      // Add the term to the database. 
      db.terms.put({"term": term, "definition": definition});
    }
  }

  /**
   * Function to handle adding an entry to the database. 
   */
  function hideEntries() {
    // no entries in current-entries
    if (!(qsa("li").length || $("current-entries").classList.contains("hidden"))) { 
      $("current-entries").classList.add("hidden");
    }
  }
  
  /**
    *  Shortcut to get the document element by id
    *  @param the string value of the ID of the DOM element you are getting
    *  @return the DOM element with that particular ID
    */
  function $(id) {
    return document.getElementById(id);
  }

  /**
    *  Shortcut to get the all of the document elements by query selector
    *  @param the string value of the query selector of the DOM elements you are getting
    *  @return the DOM elements with that particular query selector
    */
  function qsa(query) {
    return document.querySelectorAll(query);
  }

})();

